View Issue Details

IDProjectCategoryView StatusLast Update
17159Bug reportsMenu systempublic2021-03-08 19:33
ReporterPMagel Assigned Toollehar  
PriorityhighSeverityblock 
Status closedResolutionfixed 
Product Version4.4.0-RC2 
Fixed in Version4.4.12 
Summary17159: Question type: Array dual scale doesn't save state.
DescriptionWe found a Problem regarding the Array dual scale question type.
When you create It with the multiple entries then there and select some of them, but not all necessary are selected and try to go to the next question, it shows you that you have to select all necessary ones. But it also deletes all the previous selected ones.
Steps To ReproduceJust create 2 questions, first a Array dual scale type and the second one I selected a Long free text as an example.
The first one needs multiple entries.
Or you take the import file I provided for example.
Additional InformationWe found a solution for this in the file 'application/core/QuestionTypes/ArrayMultiscale/QuestionBaseRenderer.php'. It has to be changed on multiple places.

1. On Line 244-247:

$myfid1 = $this->sSGQA.$oQuestionRow->title.'_1';

$aData['aSubQuestions'][$i]['title'] = $oQuestionRow->title; // this line was added
$aData['aSubQuestions'][$i]['myfname'] = $myfname;

2. On Line 279:

if (!empty($this->getFromSurveySession($myfname0)) && $this->getFromSurveySession($myfname0) == $ld) {

was replaced with this:

if (!is_null($this->getFromSurveySession($myfname0)) && $this->getFromSurveySession($myfname0) == $ld) {

3. On Line 311:

if (!empty($this->getFromSurveySession($myfname1)) && $this->getFromSurveySession($myfname1) == $ld) {

was replaced with this:

if (!is_null($this->getFromSurveySession($myfname1)) && $this->getFromSurveySession($myfname1) == $ld) {

This solves the Problem.
TagsNo tags attached.
Complete LimeSurvey version number (& build)Version 4.4.0-RC4+210120 on my PC but also in version 4.3.30.
I will donate to the project if issue is resolvedYes
BrowserChrome
Database & DB-VersionPostgresSQL
Server OS (if known)commentary at the end
Webserver software & version (if known)
PHP Version7.4.15

Activities

PMagel

PMagel

2021-03-03 12:45

reporter  

ollehar

ollehar

2021-03-03 14:22

administrator   ~62642

You're using an outdated version of LimeSurvey. Please update to the latest version and check if the bug can still be reproduced. Thank you.
PMagel

PMagel

2021-03-03 14:51

reporter   ~62654

I now tested it on version 4.4.11+210301 and the bug is still there. I also tested the described solution and it also worked in this version.
ollehar

ollehar

2021-03-03 14:56

administrator   ~62658

Can you enable debug = 2 in application/config/config.php and try again, please? Paste the complete error message here.
PMagel

PMagel

2021-03-04 11:24

reporter   ~62708

As you told me, I enabled the debug mode, then I specified a 'error_log' destination and there are no errors showing. I even put a test 'error_log()' in the functions that are related to the problem and they are shown as expected.
ollehar

ollehar

2021-03-04 19:40

administrator   ~62736

Correct file is: application/core/QuestionTypes/ArrayMultiscale/RenderArrayMultiscale.php
ollehar1

ollehar1

2021-03-04 19:42

reporter   ~62737

Fix committed to master branch: http://bugs.limesurvey.org/plugin.php?page=Source/view&id=31260
PMagel

PMagel

2021-03-04 19:45

reporter   ~62739

Oh sorry, I forgot to change the directory when creating this bug report. Yes this is the right .php file.

Related Changesets

LimeSurvey: master 92cf20fa

2021-03-04 19:42:24

ollehar1

Details Diff
Fixed issue 17159: Question type: Array dual scale doesn't save state

Thanks to PMagel for supplying the fix.
Affected Issues
17159
mod - application/core/QuestionTypes/ArrayMultiscale/RenderArrayMultiscale.php Diff File

Issue History

Date Modified Username Field Change
2021-03-03 12:45 PMagel New Issue
2021-03-03 12:45 PMagel File Added: limesurvey_survey_532994.lss
2021-03-03 14:22 ollehar Assigned To => ollehar
2021-03-03 14:22 ollehar Status new => feedback
2021-03-03 14:22 ollehar Note Added: 62642
2021-03-03 14:51 PMagel Note Added: 62654
2021-03-03 14:51 PMagel Status feedback => assigned
2021-03-03 14:54 ollehar Priority none => high
2021-03-03 14:54 ollehar Severity minor => block
2021-03-03 14:54 ollehar Description Updated View Revisions
2021-03-03 14:54 ollehar Steps to Reproduce Updated View Revisions
2021-03-03 14:54 ollehar Additional Information Updated View Revisions
2021-03-03 14:56 ollehar Note Added: 62658
2021-03-04 11:24 PMagel Note Added: 62708
2021-03-04 19:40 ollehar Note Added: 62736
2021-03-04 19:42 ollehar1 Changeset attached => LimeSurvey master 92cf20fa
2021-03-04 19:42 ollehar1 Note Added: 62737
2021-03-04 19:44 ollehar Status assigned => resolved
2021-03-04 19:44 ollehar Resolution open => fixed
2021-03-04 19:45 PMagel Note Added: 62739
2021-03-08 19:31 c_schmitz Fixed in Version => 4.4.12
2021-03-08 19:33 c_schmitz Status resolved => closed